#ifndef CAMERA_KALMAN_H_
#define CAMERA_KALMAN_H_

#include <cv.h>

class CameraKalman{
	//trida urcena pro trackovani kamery ve 3D prostoru
public:
	CameraKalman();
	~CameraKalman();

	int init(CvMat * position, CvMat * rotation);	//inicializace pocatecniho stavu
	int predict(CvMat * position, CvMat * rotation);//predikce kalmana na zaklade minulych dat
	int update(CvMat * position, CvMat * rotation);//update namerenych(skutecnych hodnot)
protected:
	CvKalman * kalman;
  bool inited;
	//CvRandState rng;
};

class OptFlowTracker{
public:
	OptFlowTracker();
	~OptFlowTracker();

	int track(IplImage* grey, CvPoint2D32f * corners, char * status, int count, bool subpix_precise);
protected:
	IplImage * prev_grey, * pyramid, *prev_pyramid;
	bool inited;
	int flags;
};

#endif